git-clone documentation
[git/dscho.git] / git-parse-remote.sh
blob6ae534bf89a7a1fd0bfeee4248c37b4ea71290b9
1 #!/bin/sh
3 # git-ls-remote could be called from outside a git managed repository;
4 # this would fail in that case and would issue an error message.
5 GIT_DIR=$(git-rev-parse --git-dir 2>/dev/null) || :;
7 get_data_source () {
8 case "$1" in
9 */*)
10 # Not so fast. This could be the partial URL shorthand...
11 token=$(expr "z$1" : 'z\([^/]*\)/')
12 remainder=$(expr "z$1" : 'z[^/]*/\(.*\)')
13 if test "$(git-repo-config --get "remote.$token.url")"
14 then
15 echo config-partial
16 elif test -f "$GIT_DIR/branches/$token"
17 then
18 echo branches-partial
19 else
20 echo ''
24 if test "$(git-repo-config --get "remote.$1.url")"
25 then
26 echo config
27 elif test -f "$GIT_DIR/remotes/$1"
28 then
29 echo remotes
30 elif test -f "$GIT_DIR/branches/$1"
31 then
32 echo branches
33 else
34 echo ''
35 fi ;;
36 esac
39 get_remote_url () {
40 data_source=$(get_data_source "$1")
41 case "$data_source" in
42 '')
43 echo "$1" ;;
44 config-partial)
45 token=$(expr "z$1" : 'z\([^/]*\)/')
46 remainder=$(expr "z$1" : 'z[^/]*/\(.*\)')
47 url=$(git-repo-config --get "remote.$token.url")
48 echo "$url/$remainder"
50 config)
51 git-repo-config --get "remote.$1.url"
53 remotes)
54 sed -ne '/^URL: */{
55 s///p
57 }' "$GIT_DIR/remotes/$1" ;;
58 branches)
59 sed -e 's/#.*//' "$GIT_DIR/branches/$1" ;;
60 branches-partial)
61 token=$(expr "z$1" : 'z\([^/]*\)/')
62 remainder=$(expr "z$1" : 'z[^/]*/\(.*\)')
63 url=$(sed -e 's/#.*//' "$GIT_DIR/branches/$token")
64 echo "$url/$remainder"
67 die "internal error: get-remote-url $1" ;;
68 esac
71 get_default_remote () {
72 curr_branch=$(git-symbolic-ref HEAD | sed -e 's|^refs/heads/||')
73 origin=$(git-repo-config --get "branch.$curr_branch.remote")
74 echo ${origin:-origin}
77 get_remote_default_refs_for_push () {
78 data_source=$(get_data_source "$1")
79 case "$data_source" in
80 '' | config-partial | branches | branches-partial)
81 ;; # no default push mapping, just send matching refs.
82 config)
83 git-repo-config --get-all "remote.$1.push" ;;
84 remotes)
85 sed -ne '/^Push: */{
86 s///p
87 }' "$GIT_DIR/remotes/$1" ;;
89 die "internal error: get-remote-default-ref-for-push $1" ;;
90 esac
93 # Called from canon_refs_list_for_fetch -d "$remote", which
94 # is called from get_remote_default_refs_for_fetch to grok
95 # refspecs that are retrieved from the configuration, but not
96 # from get_remote_refs_for_fetch when it deals with refspecs
97 # supplied on the command line. $ls_remote_result has the list
98 # of refs available at remote.
99 expand_refs_wildcard () {
100 for ref
102 lref=${ref#'+'}
103 # a non glob pattern is given back as-is.
104 expr "z$lref" : 'zrefs/.*/\*:refs/.*/\*$' >/dev/null || {
105 echo "$ref"
106 continue
109 from=`expr "z$lref" : 'z\(refs/.*/\)\*:refs/.*/\*$'`
110 to=`expr "z$lref" : 'zrefs/.*/\*:\(refs/.*/\)\*$'`
111 local_force=
112 test "z$lref" = "z$ref" || local_force='+'
113 echo "$ls_remote_result" |
115 IFS=' '
116 while read sha1 name
118 mapped=${name#"$from"}
119 if test "z$name" != "z${name%'^{}'}" ||
120 test "z$name" = "z$mapped"
121 then
122 continue
124 echo "${local_force}${name}:${to}${mapped}"
125 done
127 done
130 # Subroutine to canonicalize remote:local notation.
131 canon_refs_list_for_fetch () {
132 # If called from get_remote_default_refs_for_fetch
133 # leave the branches in branch.${curr_branch}.merge alone,
134 # or the first one otherwise; add prefix . to the rest
135 # to prevent the secondary branches to be merged by default.
136 merge_branches=
137 found_mergeref=
138 curr_branch=
139 if test "$1" = "-d"
140 then
141 shift ; remote="$1" ; shift
142 if test "$remote" = "$(get_default_remote)"
143 then
144 curr_branch=$(git-symbolic-ref HEAD | \
145 sed -e 's|^refs/heads/||')
146 merge_branches=$(git-repo-config \
147 --get-all "branch.${curr_branch}.merge")
149 set x $(expand_refs_wildcard "$@")
150 shift
152 for ref
154 force=
155 case "$ref" in
157 ref=$(expr "z$ref" : 'z+\(.*\)')
158 force=+
160 esac
161 expr "z$ref" : 'z.*:' >/dev/null || ref="${ref}:"
162 remote=$(expr "z$ref" : 'z\([^:]*\):')
163 local=$(expr "z$ref" : 'z[^:]*:\(.*\)')
164 dot_prefix=.
165 if test -z "$merge_branches"
166 then
167 merge_branches=$remote
168 dot_prefix=
169 else
170 for merge_branch in $merge_branches
172 [ "$remote" = "$merge_branch" ] &&
173 dot_prefix= && break
174 done
176 if test -z $dot_prefix
177 then
178 found_mergeref=true
180 case "$remote" in
181 '') remote=HEAD ;;
182 refs/heads/* | refs/tags/* | refs/remotes/*) ;;
183 heads/* | tags/* | remotes/* ) remote="refs/$remote" ;;
184 *) remote="refs/heads/$remote" ;;
185 esac
186 case "$local" in
187 '') local= ;;
188 refs/heads/* | refs/tags/* | refs/remotes/*) ;;
189 heads/* | tags/* | remotes/* ) local="refs/$local" ;;
190 *) local="refs/heads/$local" ;;
191 esac
193 if local_ref_name=$(expr "z$local" : 'zrefs/\(.*\)')
194 then
195 git-check-ref-format "$local_ref_name" ||
196 die "* refusing to create funny ref '$local_ref_name' locally"
198 echo "${dot_prefix}${force}${remote}:${local}"
199 done
200 if test -z "$found_mergeref" -a "$curr_branch"
201 then
202 echo >&2 "Warning: No merge candidate found because value of config option
203 \"branch.${curr_branch}.merge\" does not match any remote branch fetched."
207 # Returns list of src: (no store), or src:dst (store)
208 get_remote_default_refs_for_fetch () {
209 data_source=$(get_data_source "$1")
210 case "$data_source" in
211 '' | config-partial | branches-partial)
212 echo "HEAD:" ;;
213 config)
214 canon_refs_list_for_fetch -d "$1" \
215 $(git-repo-config --get-all "remote.$1.fetch") ;;
216 branches)
217 remote_branch=$(sed -ne '/#/s/.*#//p' "$GIT_DIR/branches/$1")
218 case "$remote_branch" in '') remote_branch=master ;; esac
219 echo "refs/heads/${remote_branch}:refs/heads/$1"
221 remotes)
222 canon_refs_list_for_fetch -d "$1" $(sed -ne '/^Pull: */{
223 s///p
224 }' "$GIT_DIR/remotes/$1")
227 die "internal error: get-remote-default-ref-for-push $1" ;;
228 esac
231 get_remote_refs_for_push () {
232 case "$#" in
233 0) die "internal error: get-remote-refs-for-push." ;;
234 1) get_remote_default_refs_for_push "$@" ;;
235 *) shift; echo "$@" ;;
236 esac
239 get_remote_refs_for_fetch () {
240 case "$#" in
242 die "internal error: get-remote-refs-for-fetch." ;;
244 get_remote_default_refs_for_fetch "$@" ;;
246 shift
247 tag_just_seen=
248 for ref
250 if test "$tag_just_seen"
251 then
252 echo "refs/tags/${ref}:refs/tags/${ref}"
253 tag_just_seen=
254 continue
255 else
256 case "$ref" in
257 tag)
258 tag_just_seen=yes
259 continue
261 esac
263 canon_refs_list_for_fetch "$ref"
264 done
266 esac
269 resolve_alternates () {
270 # original URL (xxx.git)
271 top_=`expr "z$1" : 'z\([^:]*:/*[^/]*\)/'`
272 while read path
274 case "$path" in
275 \#* | '')
276 continue ;;
278 echo "$top_$path/" ;;
279 ../*)
280 # relative -- ugly but seems to work.
281 echo "$1/objects/$path/" ;;
283 # exit code may not be caught by the reader.
284 echo "bad alternate: $path"
285 exit 1 ;;
286 esac
287 done